package ppds;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.util.Arrays;
import java.util.List;

import org.apache.commons.lang3.tuple.Pair;
import org.junit.Test;

import ppds.Types.ErrCode;
import ppds.Types.KeyType;

public class GetTest {
    public IdxState ixstate = null;
    public IXServer ixserver = new IXServer();

    @Test
    public void insertTest() throws InterruptedException {

        ErrCode ret1 = null;

        Pair<ErrCode, IdxState> pIdx =  ixserver.openIndex("primary_index");
        ixstate = pIdx.getRight();
//        assertEquals("could not open primary index", ErrCode.SUCCESS.name(), pIdx.getLeft().toString());

         for (int i = 0; i < 100; i++) {
            Key<?> key = new Key<>(KeyType.INT, i);
            String value = "value ";
             if (i < 10) {
                 value = value.concat("0" + i);
             }
            else {
                 value = value.concat(String.valueOf(i));
             }

             Record record = new Record(key);

             ret1 = ixserver.get(ixstate, null, record);
             assertEquals("could not get(" + i + ") without a transaction", ErrCode.SUCCESS.name(), ret1.toString());
             Object kv = record.getKey().getKeyval();
             assertEquals("failed to retrieve " + i + ", " + value + " from get call outside of transaction", i, kv);
             assertEquals("failed to retrieve " + i + ", " + value + " from get call outside of transaction", value, record.getPayload());
        }

        if (ixserver.closeIndex(ixstate) != ErrCode.SUCCESS) {
            System.out.println("Could not close primary index");
        }

        if (ixserver.drop("primary_index") != ErrCode.SUCCESS) {
            System.out.println("Could not drop primary index");
        }
    }
}
